#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define nfl 6		/* The number of floors */
#define epsilon 1.0E-4	/* The accuracy of the computation */

double prob[nfl];	/* The probabilities */
double cum[nfl+1];	/* The cumulative probabilities */

void lifttime(double t)	{
   int in, j, out;
   double sum, tm;
/*
 *     Loop over initial and final floors
 */
   for (in=0; in<nfl; in++) {
      sum = 0.0;
      for (j=0; j<nfl; j++)
         sum += prob[j]*abs(j-in);
      printf("%d",in);
      for (out=0; out<nfl; out++) {
         tm = (in == out) ?
              0.0 : (in < out) ?
                 out-in + sum + t*(0.5 + cum[out-1]-cum[in]
                     -cum[in]*(1-cum[in-1])) :
                 in-out + sum + t*(0.5 + cum[in]-cum[out+1]
                     -cum[in]*(1-cum[in-1]));
         printf(" %7.1f",15*abs(in-out)-tm);
         }
       printf("\n");
      }
}
void prepare() {
   int j;

/*
 *     The definition is exactly that in the notes
 */
   cum[0] = 0.0;
   for (j=1; j<nfl+1; j++)
      cum[j] = cum[j-1] + prob[j-1];
}
int main(){
   int j, k;
   double t;
/*
 *     Outer loop over K, inner loop over t
 */
      for (k=1; k<21; k++) {
          
/*
 *        Set up the model
 */
         prob[0] = (double) 1.0/((double) nfl-1+k);
         for (j=1; j<nfl; j++)
             prob[j] = prob[0];
         prob[3] = k*prob[3];
         prepare();
/*
 *        Loop over the remaining model parameter
 */
         for (j=2; j<51; j++) {
            t=j*0.5;
            printf("\n\nK= %d, t=%4.1f\n",k, t);
            lifttime(t);
            }
         }
   return 0;
}
