      subroutine lifttime(t)	! compute the lift travel time
      parameter (nfl = 6)
      real tm(nfl)
      common /model/ prob(nfl), cum(0:nfl)
*
*     Loop over initial and final floors
*
      do in = 1,nfl-1
         sum = 0.
         do j = 1,nfl
            sum = sum + prob(j)*abs(j-in)
         end do
         do ix = 1,nfl
            if (in.eq.ix) then
               tm(ix) = 0.
            else if (in.lt.ix) then
               tm(ix) = ix-in + sum + t*(0.5+
     1          cum(ix-1)-cum(in)-cum(in-1)*(1-cum(in+1)))
            else
               tm(ix) = in-ix + sum + t*(0.5+
     1          cum(in)-cum(ix+1)-cum(in-1)*(1-cum(in+1)))
            end if
         end do
         write(*,'(i4,6f7.1)') in, (15*abs(in-j)-tm(j),j=1,nfl)
      end do
*
      return
      end
      subroutine prepare       		! prepare the cumulative probs
      parameter (nfl = 6)
      common /model/ prob(nfl), cum(0:nfl)
*
*     The definition is exactly that in the notes
*
      cum(0) = 0.
      do j = 1,nfl
         cum(j) = cum(j-1) + prob(j)
      end do
*
*     Check that the input was correct
*
      if (abs(cum(nfl)-1.0).gt.1.0E-4) then
         write(*,*) 'Input probabilities do not add to unity'
         stop
      end if
*
      return
      end
      program main
      parameter (nfl = 6)
      common /model/ prob(nfl), cum(0:nfl)
*
*     Outer loop over K, inner loop over t
*
      do k = 1,20
*
*        Set up the model
*
         prob(1) = 1.0/(nfl-1+k)
         do j = 2,nfl
            prob(j) = prob(1)
         end do
         prob(3) = k*prob(3)
         call prepare
*
*        Loop over the remaining model parameter
*
         do j = 2,50
            t=j*0.5
            write(*,6001) k, t
            call lifttime(t)
         end do
      end do
*
 6001 format(//,'K=',i2,5x,'t=',f4.1)
      end
